=== debian/changelog ===
erlang (1:13.b.2.1-dfsg-2) unstable; urgency=low

  * Package for maemo5
  * Stripped a number of dependencies that are not available, like wxgtk. 

 -- Thomas Vander Stichele <thomas at apestaart dot org>  Mon,  7 Dec 2009 17:34:53 +0100

erlang (1:13.b.2.1-dfsg-1) unstable; urgency=low

  * New upstream release (closes: #539269).
  * New maintainer's email address pkg-erlang-devel@lists.alioth.debian.org
    mailing list.
  * Overridden another lintian warning about image file in /usr/lib.

 -- Sergei Golovan <sgolovan@debian.org>  Fri, 25 Sep 2009 23:45:31 +0400

erlang (1:13.b.1-dfsg-6) unstable; urgency=low

  * Restored debug info in beam files for default build. It's better to use
    more space than to ship broken modules (debugger, dialyzer). The patch
    is simply commented out in debian/patches/series, so if someone has to
    strip debug info, he can simply uncomment it.
  * Disabled SMP support for hurd-i386 architecture, because of FTBFS in case
    when SMP is enabled.
  * Added debian/README.source file with a reference to
    /usr/share/doc/quilt/README.source.
  * Bumped standards version to 3.8.3.

 -- Sergei Golovan <sgolovan@debian.org>  Tue, 18 Aug 2009 01:29:25 +0400

erlang (1:13.b.1-dfsg-5) unstable; urgency=low

  * Fixed parentheses in Emacs mode (closes: #536891).
  * Removed unnecessary conflicts with erlang-manpages package.
  * Added workaround for #475459: disabled threads on sparc architecture.
    This breaks wxErlang, so it's only a temporary solution.

 -- Sergei Golovan <sgolovan@debian.org>  Wed, 05 Aug 2009 20:54:29 +0400

erlang (1:13.b.1-dfsg-4) unstable; urgency=low

  * Made mutual dependencies of Erlang packages more parsimonious (removed
    unnecessary dependencies following erlang-depends advise).
  * Added several new options to erlang-depends tool (-v, -P, --ignore).
  * Made erlang-nox and erlang-x11 transitional packages (which will be
    removed after squeeze release).
  * Guarded change in the m68k patch for non-m68k architectures.
  * Fixed building Erlang VM with debug information compiled in. Added a few
    words about debug build to README.Debian.

 -- Sergei Golovan <sgolovan@debian.org>  Fri, 24 Jul 2009 15:02:33 +0400

erlang (1:13.b.1-dfsg-3) unstable; urgency=low

  * Removed Torsten Werner from the uploaders list as per his request.
  * Removed full path from epmd calls in erlang-base and erlang-base-hipe
    prerm scripts.
  * Added ${erlang:Depends} substvar which expands into a list of Erlang
    packages which modules are actually used in application.
  * Bumped standards version to 3.8.2.

 -- Sergei Golovan <sgolovan@debian.org>  Tue, 30 Jun 2009 14:13:14 +0400

erlang (1:13.b.1-dfsg-2) unstable; urgency=low

  * Updated manpages for section 1.
  * Applied patch by James Henstridge, which sets ERL_COMPILE_FLAGS based on
    DEB_BUILD_OPTIONS. By default slim runtime without debug info is built.
    To remove slim option set DEB_BUILD_OPTION to 'nostrip', to add debug_info
    compiler option set DEB_BUILD_OPTION to 'debug'. Or it may be set to
    'nostrip,debug' to return to the previous level ob debug information
    (closes: #532757).
  * Added a few words about building Erlang packages with debug info included
    to README.Debian.

 -- Sergei Golovan <sgolovan@debian.org>  Wed, 17 Jun 2009 08:49:38 +0400

erlang (1:13.b.1-dfsg-1) unstable; urgency=low

  * New upstream release.
  * Removed unnecessary dependency of erlang-os-mon on erlang-observer and
    erlang-tools and added missing dependency of erlang-nox on erlang-os-mon
    (closes: #529512).
  * Removed a patch to eunit application because the bug was fixed upstream.

 -- Sergei Golovan <sgolovan@debian.org>  Thu, 11 Jun 2009 12:18:07 +0400

erlang (1:13.b-dfsg1-1) unstable; urgency=low

  * Removed another bunch of non-free RFCs from original tarball
    (closes: #527053).
  * Fixed build-dependencies list by adding missing comma. This requires
    libsctp-dev again. Also, added libsctp1 dependency to erlang-base and
    erlang-base-hipe packages because the shared library is loaded via
    dlopen now and cannot be added using dh_slibdeps (closes: #526682).
  * Weakened dependency of erlang-webtool on erlang-observer to recommends
    to avoid circular dependencies (closes: #526627).
  * Added solaris-i386 to HiPE enabled architectures.
  * Made script sources in /usr/lib/erlang/erts-*/bin directory executable,
    which is more convenient if a user wants to create a target Erlang system.
  * Shortened extended description line for erlang-dev package to make it
    fit 80x25 terminals.

 -- Sergei Golovan <sgolovan@debian.org>  Thu, 07 May 2009 15:07:37 +0400

erlang (1:13.b-dfsg-2) unstable; urgency=low

  * Cleaned up patches: removed unneeded patch which helped to support
    different SCTP library versions, made sure that changes for m68k
    architecture applied only when building on this architecture.
  * Removed duplicated information from binary packages descriptions.
  * Don't require libsctp-dev build-dependency on solaris-i386 architecture
    which allows to build Erlang on Nexenta (thanks to Tim Spriggs for
    the suggestion).

 -- Sergei Golovan <sgolovan@debian.org>  Fri, 01 May 2009 10:14:38 +0400

erlang (1:13.b-dfsg-1) experimental; urgency=low

  * New upstream release.
  * Reduced number of packaged in build dependencies (removed unnecessary
    freeglut3-dev).
  * Added all new packages to erlang-depends script.
  * Put start scripts and releases sources into erlang-src package. They
    are needed when a target Erlang system is to be created.
  * Temporarily changed architecture of erlang-nox and erlang-x11 packages
    from all to any. Otherwise they will be broken during transition period
    when the new split Erlang is uploaded but isn't built on all architectures
    yet.
  * Added a patch which fixes backquote syntax in Erlang mode for Emacs
    (closes: #494823). Thanks to Balint Reczey.

